<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: Graph APIs</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Graph APIs<br/>
<small>
[<a class="el" href="group__group__vx__framework__object.html">Framework Objects</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__graph__t.html">tivx_graph_t</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The top level data for graph object.  <a href="structtivx__graph__t.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int32_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__graph.html#ga382c7c56a26c11ef3ab4d53ee067a801">ownGraphGetFreeNodeIndex</a> (<a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a> graph)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get next free node entry in graph.  <a href="#ga382c7c56a26c11ef3ab4d53ee067a801"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__graph.html#ga3cdd9e3db44e005e8f327756fd47d9dc">ownGraphAddNode</a> (<a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a> graph, <a class="el" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96">vx_node</a> node, int32_t index)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add's a node to a graph.  <a href="#ga3cdd9e3db44e005e8f327756fd47d9dc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__graph.html#ga9830a8a2a45de2cdc01865061fb59ed8">ownGraphRemoveNode</a> (<a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a> graph, <a class="el" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96">vx_node</a> node)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Remove a node from a graph.  <a href="#ga9830a8a2a45de2cdc01865061fb59ed8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__graph.html#gadccdfaff993b98451a9d159c96e8cbf4">ownGraphTopologicalSort</a> (<a class="el" href="structtivx__graph__sort__context.html">tivx_graph_sort_context</a> *context, <a class="el" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96">vx_node</a> *nodes, uint32_t num_nodes, <a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a> *has_cycle)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Perform topological sort of graph nodes.  <a href="#gadccdfaff993b98451a9d159c96e8cbf4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__vx__graph.html#ga8f66ba30fd30e78b86621bafd1b5b04c">ownGraphSetReverify</a> (<a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a> graph)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Mark graph to be reverified.  <a href="#ga8f66ba30fd30e78b86621bafd1b5b04c"></a><br/></td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga382c7c56a26c11ef3ab4d53ee067a801"></a><!-- doxytag: member="vx_graph.h::ownGraphGetFreeNodeIndex" ref="ga382c7c56a26c11ef3ab4d53ee067a801" args="(vx_graph graph)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t ownGraphGetFreeNodeIndex </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a>&nbsp;</td>
          <td class="paramname"> <em>graph</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get next free node entry in graph. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>graph</em>&nbsp;</td><td>[in] graph object</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>0 or more value, index of node in graph </dd>
<dd>
-1, all nodes in graph are used and free node not found </dd></dl>

</div>
</div>
<a class="anchor" id="ga3cdd9e3db44e005e8f327756fd47d9dc"></a><!-- doxytag: member="vx_graph.h::ownGraphAddNode" ref="ga3cdd9e3db44e005e8f327756fd47d9dc" args="(vx_graph graph, vx_node node, int32_t index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> ownGraphAddNode </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a>&nbsp;</td>
          <td class="paramname"> <em>graph</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96">vx_node</a>&nbsp;</td>
          <td class="paramname"> <em>node</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&nbsp;</td>
          <td class="paramname"> <em>index</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add's a node to a graph. </p>
<p>'index' should be the one that is returned via <a class="el" href="group__group__vx__graph.html#ga382c7c56a26c11ef3ab4d53ee067a801" title="Get next free node entry in graph.">ownGraphGetFreeNodeIndex()</a></p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>graph</em>&nbsp;</td><td>[in] graph object </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>node</em>&nbsp;</td><td>[in] the node to add </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>index</em>&nbsp;</td><td>[in] the index in graph at which to add the node</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS, on sucess </dd></dl>

</div>
</div>
<a class="anchor" id="ga9830a8a2a45de2cdc01865061fb59ed8"></a><!-- doxytag: member="vx_graph.h::ownGraphRemoveNode" ref="ga9830a8a2a45de2cdc01865061fb59ed8" args="(vx_graph graph, vx_node node)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> ownGraphRemoveNode </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a>&nbsp;</td>
          <td class="paramname"> <em>graph</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96">vx_node</a>&nbsp;</td>
          <td class="paramname"> <em>node</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a node from a graph. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>graph</em>&nbsp;</td><td>[in] graph object </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>node</em>&nbsp;</td><td>[in] the node to remove</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS, on sucess </dd></dl>

</div>
</div>
<a class="anchor" id="gadccdfaff993b98451a9d159c96e8cbf4"></a><!-- doxytag: member="vx_graph.h::ownGraphTopologicalSort" ref="gadccdfaff993b98451a9d159c96e8cbf4" args="(tivx_graph_sort_context *context, vx_node *nodes, uint32_t num_nodes, vx_bool *has_cycle)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ownGraphTopologicalSort </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__graph__sort__context.html">tivx_graph_sort_context</a> *&nbsp;</td>
          <td class="paramname"> <em>context</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7f1b5d91fac63093ee3a77e87d942f96">vx_node</a> *&nbsp;</td>
          <td class="paramname"> <em>nodes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>num_nodes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7ab7c7864a0ea6762a9e15be80ef28f0">vx_bool</a> *&nbsp;</td>
          <td class="paramname"> <em>has_cycle</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Perform topological sort of graph nodes. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>context</em>&nbsp;</td><td>[in] context to use while sorting </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>nodes</em>&nbsp;</td><td>[in/out] IN: Unosrted node, OUT: Sorted nodes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>num_nodes</em>&nbsp;</td><td>[in] Number of nodes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>has_cycle</em>&nbsp;</td><td>[out] vx_true_e: Graph has cycles and cannot be sorted vx_false_e: Graph is acyclic and nodes[] contains the sorted nodes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga8f66ba30fd30e78b86621bafd1b5b04c"></a><!-- doxytag: member="vx_graph.h::ownGraphSetReverify" ref="ga8f66ba30fd30e78b86621bafd1b5b04c" args="(vx_graph graph)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ownGraphSetReverify </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="vx__types_8h.html#a7e71c08b1777e49abaf4417506ca8451">vx_graph</a>&nbsp;</td>
          <td class="paramname"> <em>graph</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Mark graph to be reverified. </p>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
